List the function runtimes
GET /function_runtimes
List all valid function runtimes.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Request
Response
200 - OK
function_runtimes
array
List of all Function runtimes.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
List all projects
GET /projects
List all projects in the current account.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
resource-controller.instance.retrieve
Request
Path Parameters
Query Parameters
limit
integer
Optional maximum number of projects per page.
start
string
An optional token that indicates the beginning of the page of results to be returned. Any additional query parameters are ignored if a page token is present. If omitted, the first page of results is returned. This value is obtained from the 'start' query parameter in the `next` object of the operation response.
Response
200 - OK
first
ListFirstMetadata
Describes properties needed to retrieve the first page of a result list.
limit
integer
Maximum number of resources per page.
next
ListNextMetadata
Describes properties needed to retrieve the next page of a result list.
projects
array
List of projects.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Create a project
POST /projects
Create a Code Engine project on IBM Cloud. The project will be created in the region that corresponds to the API endpoint that is being called.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
resource-controller.instance.create
Auditing
Calling this method generates the following auditing event.
resource-controller.instance.create
Request
Request Body
ProjectPrototype
Project prototype
name
Required *
string
The name of the project.
resource_group_id
string
Optional ID of the resource group for your project deployment. If this field is not defined, the default resource group of the account will be used.
tags
array
Optional list of labels to assign to your project. Tags are not part of the project resource that is returned by the server, but can be obtained and managed through the Global Tagging API in IBM Cloud. Find more information on Global Tagging API docs.
Response
202 - Accepted
account_id
string
The ID of the account of the project, e.g. 4329073d16d2f3663f74bfa955259139.
created_at
string
The timestamp when the project was created.
crn
string
The CRN of the project.
href
string
When you provision a new resource, a URL is created identifying the location of the instance.
id
string
The ID of the project.
name
string
The name of the project.
region
string
The region for your project deployment. Possible values: 'au-syd', 'br-sao', 'ca-tor', 'eu-de', 'eu-gb', 'jp-osa', 'jp-tok', 'us-east', 'us-south'.
resource_group_id
string
The ID of the resource group.
resource_type
string
The type of the project.
status
string
The current state of the project. For example, when the project is created and is ready for use, the status of the project is active.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Delete a project
DELETE /projects/{id}
Delete a project.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
resource-controller.instance.delete
Auditing
Calling this method generates the following auditing event.
resource-controller.instance.delete
Request
Response
202 - Accepted
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Get a project
GET /projects/{id}
Display the details of a single project.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
resource-controller.instance.retrieve
Request
Response
200 - OK
account_id
string
The ID of the account of the project, e.g. 4329073d16d2f3663f74bfa955259139.
created_at
string
The timestamp when the project was created.
crn
string
The CRN of the project.
href
string
When you provision a new resource, a URL is created identifying the location of the instance.
id
string
The ID of the project.
name
string
The name of the project.
region
string
The region for your project deployment. Possible values: 'au-syd', 'br-sao', 'ca-tor', 'eu-de', 'eu-gb', 'jp-osa', 'jp-tok', 'us-east', 'us-south'.
resource_group_id
string
The ID of the resource group.
resource_type
string
The type of the project.
status
string
The current state of the project. For example, when the project is created and is ready for use, the status of the project is active.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
List allowed outbound destinations
GET /projects/{project_id}/allowed_outbound_destinations
List all allowed outbound destinations in a project.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.allowedoutbounddestination.list
Request
Path Parameters
Query Parameters
limit
integer
Optional maximum number of allowed outbound destinations per page.
start
string
An optional token that indicates the beginning of the page of results to be returned. If omitted, the first page of results is returned. This value is obtained from the 'start' query parameter in the `next` object of the operation response.
Response
200 - OK
allowed_outbound_destinations
array
List of all allowed outbound destinations.
first
ListFirstMetadata
Describes properties needed to retrieve the first page of a result list.
limit
integer
Maximum number of resources per page.
next
ListNextMetadata
Describes properties needed to retrieve the next page of a result list.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Create an allowed outbound destination
POST /projects/{project_id}/allowed_outbound_destinations
Create an allowed outbound destination.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.update
Auditing
Calling this method generates the following auditing event.
codeengine.allowedoutbounddestination.create
Request
Request Body
AllowedOutboundDestinationPrototype
AllowedOutboundDestination prototype
name
Required *
string
The name of the allowed outbound destination.
type
Required *
string
Specify the type of the allowed outbound destination. Allowed types are: `cidr_block` and `private_path_service_gateway`.
Path Parameters
Query Parameters
version
string
The API version, in format `YYYY-MM-DD`. For the API behavior documented here, specify any date between `2021-03-31` and `2026-11-03`.
Response
201 - Created
entity_tag
string
The version of the allowed outbound destination, which is used to achieve optimistic locking.
name
string
The name of the allowed outbound destination.
project_id
string
The ID of the project in which the resource is located.
status
string
The current status of the outbound destination.
status_details
AllowedOutboundStatusDetails
type
string
Specify the type of the allowed outbound destination. Allowed types are: `cidr_block` and `private_path_service_gateway`.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Delete an allowed outbound destination
DELETE /projects/{project_id}/allowed_outbound_destinations/{name}
Delete an allowed outbound destination.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.update
Auditing
Calling this method generates the following auditing event.
codeengine.allowedoutbounddestination.delete
Request
Response
202 - Accepted
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Get an allowed outbound destination
GET /projects/{project_id}/allowed_outbound_destinations/{name}
Display the details of an allowed outbound destination.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.allowedoutbounddestination.read
Request
Response
200 - OK
entity_tag
string
The version of the allowed outbound destination, which is used to achieve optimistic locking.
name
string
The name of the allowed outbound destination.
project_id
string
The ID of the project in which the resource is located.
status
string
The current status of the outbound destination.
status_details
AllowedOutboundStatusDetails
type
string
Specify the type of the allowed outbound destination. Allowed types are: `cidr_block` and `private_path_service_gateway`.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Update an allowed outbound destination
PATCH /projects/{project_id}/allowed_outbound_destinations/{name}
Update an allowed outbound destination.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.update
Auditing
Calling this method generates the following auditing event.
codeengine.allowedoutbounddestination.readcodeengine.allowedoutbounddestination.update
Request
Request Body
AllowedOutboundDestination patch
Path Parameters
Query Parameters
Response
200 - OK
entity_tag
string
The version of the allowed outbound destination, which is used to achieve optimistic locking.
name
string
The name of the allowed outbound destination.
project_id
string
The ID of the project in which the resource is located.
status
string
The current status of the outbound destination.
status_details
AllowedOutboundStatusDetails
type
string
Specify the type of the allowed outbound destination. Allowed types are: `cidr_block` and `private_path_service_gateway`.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
List applications
GET /projects/{project_id}/apps
List all applications in a project.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.application.list
Request
Path Parameters
Query Parameters
limit
integer
Optional maximum number of apps per page.
start
string
An optional token that indicates the beginning of the page of results to be returned. If omitted, the first page of results is returned. This value is obtained from the 'start' query parameter in the `next` object of the operation response.
Response
200 - OK
apps
array
List of all apps.
first
ListFirstMetadata
Describes properties needed to retrieve the first page of a result list.
limit
integer
Maximum number of resources per page.
next
ListNextMetadata
Describes properties needed to retrieve the next page of a result list.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Create an application
POST /projects/{project_id}/apps
Create an application.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.create
Auditing
Calling this method generates the following auditing event.
codeengine.application.create
Request
Request Body
AppPrototype
App prototype
image_port
integer
Optional port the app listens on. While the app will always be exposed via port `443` for end users, this port is used to connect to the port that is exposed by the container image.
image_reference
Required *
string
The name of the image that is used for this app. The format is `REGISTRY/NAMESPACE/REPOSITORY:TAG` where `REGISTRY` and `TAG` are optional. If `REGISTRY` is not specified, the default is `docker.io`. If `TAG` is not specified, the default is `latest`. If the image reference points to a registry that requires authentication, make sure to also specify the property `image_secret`.
image_secret
string
Optional name of the image registry access secret. The image registry access secret is used to authenticate with a private registry when you download the container image. If the image reference points to a registry that requires authentication, the app will be created but cannot reach the ready status, until this property is provided, too.
managed_domain_mappings
string
Optional value controlling which of the system managed domain mappings will be setup for the application. Valid values are 'local_public', 'local_private' and 'local'. Visibility can only be 'local_private' if the project supports application private visibility.
name
Required *
string
The name of the app. Use a name that is unique within the project.
probe_liveness
ProbePrototype
Request model for probes
failure_threshold
integer
The number of consecutive, unsuccessful checks for the probe to be considered failed.
initial_delay
integer
The amount of time in seconds to wait before the first probe check is performed.
interval
integer
The amount of time in seconds between probe checks.
path
string
The path of the HTTP request to the resource. A path is only supported for a probe with a `type` of `http`.
port
integer
The port on which to probe the resource.
timeout
integer
The amount of time in seconds that the probe waits for a response from the application before it times out and fails.
type
string
Specifies whether to use HTTP or TCP for the probe checks. The default is TCP.
probe_readiness
ProbePrototype
Request model for probes
failure_threshold
integer
The number of consecutive, unsuccessful checks for the probe to be considered failed.
initial_delay
integer
The amount of time in seconds to wait before the first probe check is performed.
interval
integer
The amount of time in seconds between probe checks.
path
string
The path of the HTTP request to the resource. A path is only supported for a probe with a `type` of `http`.
port
integer
The port on which to probe the resource.
timeout
integer
The amount of time in seconds that the probe waits for a response from the application before it times out and fails.
type
string
Specifies whether to use HTTP or TCP for the probe checks. The default is TCP.
run_arguments
array
Optional arguments for the app that are passed to start the container. If not specified an empty string array will be applied and the arguments specified by the container image, will be used to start the container.
run_as_user
integer
Optional user ID (UID) to run the app.
run_commands
array
Optional commands for the app that are passed to start the container. If not specified an empty string array will be applied and the command specified by the container image, will be used to start the container.
run_compute_resource_token_enabled
boolean
Optional flag to enable the use of a compute resource token mounted to the container file system.
run_env_variables
array
Optional references to config maps, secrets or literal values that are exposed as environment variables within the running application.
run_service_account
string
Optional name of the service account. For built-in service accounts, you can use the shortened names `manager` , `none`, `reader`, and `writer`.
run_volume_mounts
array
Optional mounts of config maps or a secrets.
scale_concurrency
integer
Optional maximum number of requests that can be processed concurrently per instance.
scale_concurrency_target
integer
Optional threshold of concurrent requests per instance at which one or more additional instances are created. Use this value to scale up instances based on concurrent number of requests. This option defaults to the value of the `scale_concurrency` option, if not specified.
scale_cpu_limit
string
Optional number of CPU set for the instance of the app. For valid values see Supported memory and CPU combinations.
scale_down_delay
integer
Optional amount of time in seconds that delays the scale-down behavior for an app instance.
scale_ephemeral_storage_limit
string
Optional amount of ephemeral storage to set for the instance of the app. The amount specified as ephemeral storage, must not exceed the amount of `scale_memory_limit`. The units for specifying ephemeral storage are Megabyte (M) or Gigabyte (G), whereas G and M are the shorthand expressions for GB and MB. For more information see Units of measurement.
scale_initial_instances
integer
Optional initial number of instances that are created upon app creation or app update.
scale_max_instances
integer
Optional maximum number of instances for this app. If you set this value to `0`, this property does not set a upper scaling limit. However, the app scaling is still limited by the project quota for instances. See Limits and quotas for Code Engine.
scale_memory_limit
string
Optional amount of memory set for the instance of the app. For valid values see Supported memory and CPU combinations. The units for specifying memory are Megabyte (M) or Gigabyte (G), whereas G and M are the shorthand expressions for GB and MB. For more information see Units of measurement.
scale_min_instances
integer
Optional minimum number of instances for this app. If you set this value to `0`, the app will scale down to zero, if not hit by any request for some time.
scale_request_timeout
integer
Optional amount of time in seconds that is allowed for a running app to respond to a request.
Response
201 - Created
build
string
Reference to a build that is associated with the application.
build_run
string
Reference to a build run that is associated with the application.
computed_env_variables
array
References to config maps, secrets or literal values, which are defined and set by Code Engine and are exposed as environment variables in the application.
created_at
string
The timestamp when the resource was created.
endpoint
string
Optional URL to invoke the app. Depending on visibility, this is accessible publicly or in the private network only. Empty in case 'managed_domain_mappings' is set to 'local'.
endpoint_internal
string
The URL to the app that is only visible within the project.
entity_tag
string
The version of the app instance, which is used to achieve optimistic locking.
href
string
When you provision a new app, a URL is created identifying the location of the instance.
id
string
The identifier of the resource.
image_port
integer
Optional port the app listens on. While the app will always be exposed via port `443` for end users, this port is used to connect to the port that is exposed by the container image.
image_reference
string
The name of the image that is used for this app. The format is `REGISTRY/NAMESPACE/REPOSITORY:TAG` where `REGISTRY` and `TAG` are optional. If `REGISTRY` is not specified, the default is `docker.io`. If `TAG` is not specified, the default is `latest`. If the image reference points to a registry that requires authentication, make sure to also specify the property `image_secret`.
image_secret
string
Optional name of the image registry access secret. The image registry access secret is used to authenticate with a private registry when you download the container image. If the image reference points to a registry that requires authentication, the app will be created but cannot reach the ready status, until this property is provided, too.
managed_domain_mappings
string
Optional value controlling which of the system managed domain mappings will be setup for the application. Valid values are 'local_public', 'local_private' and 'local'. Visibility can only be 'local_private' if the project supports application private visibility.
name
string
The name of the app.
probe_liveness
Probe
Response model for probes
probe_readiness
Probe
Response model for probes
project_id
string
The ID of the project in which the resource is located.
region
string
The region of the project the resource is located in. Possible values: 'au-syd', 'br-sao', 'ca-tor', 'eu-de', 'eu-gb', 'jp-osa', 'jp-tok', 'us-east', 'us-south'.
resource_type
string
The type of the app.
run_arguments
array
Optional arguments for the app that are passed to start the container. If not specified an empty string array will be applied and the arguments specified by the container image, will be used to start the container.
run_as_user
integer
Optional user ID (UID) to run the app.
run_commands
array
Optional commands for the app that are passed to start the container. If not specified an empty string array will be applied and the command specified by the container image, will be used to start the container.
run_compute_resource_token_enabled
boolean
Optional flag to enable the use of a compute resource token mounted to the container file system.
run_env_variables
array
References to config maps, secrets or literal values, which are defined by the app owner and are exposed as environment variables in the application.
run_service_account
string
Optional name of the service account. For built-in service accounts, you can use the shortened names `manager` , `none`, `reader`, and `writer`.
run_volume_mounts
array
Mounts of config maps or secrets.
scale_concurrency
integer
Optional maximum number of requests that can be processed concurrently per instance.
scale_concurrency_target
integer
Optional threshold of concurrent requests per instance at which one or more additional instances are created. Use this value to scale up instances based on concurrent number of requests. This option defaults to the value of the `scale_concurrency` option, if not specified.
scale_cpu_limit
string
Optional number of CPU set for the instance of the app. For valid values see Supported memory and CPU combinations.
scale_down_delay
integer
Optional amount of time in seconds that delays the scale-down behavior for an app instance.
scale_ephemeral_storage_limit
string
Optional amount of ephemeral storage to set for the instance of the app. The amount specified as ephemeral storage, must not exceed the amount of `scale_memory_limit`. The units for specifying ephemeral storage are Megabyte (M) or Gigabyte (G), whereas G and M are the shorthand expressions for GB and MB. For more information see Units of measurement.
scale_initial_instances
integer
Optional initial number of instances that are created upon app creation or app update.
scale_max_instances
integer
Optional maximum number of instances for this app. If you set this value to `0`, this property does not set a upper scaling limit. However, the app scaling is still limited by the project quota for instances. See Limits and quotas for Code Engine.
scale_memory_limit
string
Optional amount of memory set for the instance of the app. For valid values see Supported memory and CPU combinations. The units for specifying memory are Megabyte (M) or Gigabyte (G), whereas G and M are the shorthand expressions for GB and MB. For more information see Units of measurement.
scale_min_instances
integer
Optional minimum number of instances for this app. If you set this value to `0`, the app will scale down to zero, if not hit by any request for some time.
scale_request_timeout
integer
Optional amount of time in seconds that is allowed for a running app to respond to a request.
status
string
The current status of the app.
status_details
AppStatus
The detailed status of the application.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
List application instances
GET /projects/{project_id}/apps/{app_name}/instances
List all instances of an application.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.application.list
Request
Path Parameters
project_id
Required *
string
The ID of the project.
app_name
Required *
string
The name of your application.
Query Parameters
limit
integer
Optional maximum number of apps per page.
start
string
An optional token that indicates the beginning of the page of results to be returned. If omitted, the first page of results is returned. This value is obtained from the 'start' query parameter in the `next` object of the operation response.
version
string
The API version, in format `YYYY-MM-DD`. For the API behavior documented here, specify any date between `2021-03-31` and `2026-11-03`.
Response
200 - OK
first
ListFirstMetadata
Describes properties needed to retrieve the first page of a result list.
instances
array
List of all app instances.
limit
integer
Maximum number of resources per page.
next
ListNextMetadata
Describes properties needed to retrieve the next page of a result list.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
List application revisions
GET /projects/{project_id}/apps/{app_name}/revisions
List all application revisions in a particular application.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.application.list
Request
Path Parameters
project_id
Required *
string
The ID of the project.
app_name
Required *
string
The name of your application.
Query Parameters
limit
integer
Optional maximum number of apps per page.
start
string
An optional token that indicates the beginning of the page of results to be returned. If omitted, the first page of results is returned. This value is obtained from the 'start' query parameter in the `next` object of the operation response.
version
string
The API version, in format `YYYY-MM-DD`. For the API behavior documented here, specify any date between `2021-03-31` and `2026-11-03`.
Response
200 - OK
first
ListFirstMetadata
Describes properties needed to retrieve the first page of a result list.
limit
integer
Maximum number of resources per page.
next
ListNextMetadata
Describes properties needed to retrieve the next page of a result list.
revisions
array
List of all app revisions.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Delete an application revision
DELETE /projects/{project_id}/apps/{app_name}/revisions/{name}
Delete an application revision.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.delete
Auditing
Calling this method generates the following auditing event.
codeengine.application.delete
Request
Response
202 - Accepted
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Get an application revision
GET /projects/{project_id}/apps/{app_name}/revisions/{name}
Display the details of an application revision.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.application.read
Request
Response
200 - OK
app_name
string
Name of the associated app.
computed_env_variables
array
References to config maps, secrets or literal values, which are defined and set by Code Engine and are exposed as environment variables in the application.
created_at
string
The timestamp when the resource was created.
href
string
When you provision a new revision, a URL is created identifying the location of the instance.
id
string
The identifier of the resource.
image_port
integer
Optional port the app listens on. While the app will always be exposed via port `443` for end users, this port is used to connect to the port that is exposed by the container image.
image_reference
string
The name of the image that is used for this app. The format is `REGISTRY/NAMESPACE/REPOSITORY:TAG` where `REGISTRY` and `TAG` are optional. If `REGISTRY` is not specified, the default is `docker.io`. If `TAG` is not specified, the default is `latest`. If the image reference points to a registry that requires authentication, make sure to also specify the property `image_secret`.
image_secret
string
Optional name of the image registry access secret. The image registry access secret is used to authenticate with a private registry when you download the container image. If the image reference points to a registry that requires authentication, the app will be created but cannot reach the ready status, until this property is provided, too.
name
string
The name of the app revision.
probe_liveness
Probe
Response model for probes
probe_readiness
Probe
Response model for probes
project_id
string
The ID of the project in which the resource is located.
region
string
The region of the project the resource is located in. Possible values: 'au-syd', 'br-sao', 'ca-tor', 'eu-de', 'eu-gb', 'jp-osa', 'jp-tok', 'us-east', 'us-south'.
resource_type
string
The type of the app revision.
run_arguments
array
Optional arguments for the app that are passed to start the container. If not specified an empty string array will be applied and the arguments specified by the container image, will be used to start the container.
run_as_user
integer
Optional user ID (UID) to run the app.
run_commands
array
Optional commands for the app that are passed to start the container. If not specified an empty string array will be applied and the command specified by the container image, will be used to start the container.
run_compute_resource_token_enabled
boolean
Optional flag to enable the use of a compute resource token mounted to the container file system.
run_env_variables
array
References to config maps, secrets or literal values, which are defined by the app owner and are exposed as environment variables in the application.
run_service_account
string
Optional name of the service account. For built-in service accounts, you can use the shortened names `manager` , `none`, `reader`, and `writer`.
run_volume_mounts
array
Mounts of config maps or secrets.
scale_concurrency
integer
Optional maximum number of requests that can be processed concurrently per instance.
scale_concurrency_target
integer
Optional threshold of concurrent requests per instance at which one or more additional instances are created. Use this value to scale up instances based on concurrent number of requests. This option defaults to the value of the `scale_concurrency` option, if not specified.
scale_cpu_limit
string
Optional number of CPU set for the instance of the app. For valid values see Supported memory and CPU combinations.
scale_down_delay
integer
Optional amount of time in seconds that delays the scale-down behavior for an app instance.
scale_ephemeral_storage_limit
string
Optional amount of ephemeral storage to set for the instance of the app. The amount specified as ephemeral storage, must not exceed the amount of `scale_memory_limit`. The units for specifying ephemeral storage are Megabyte (M) or Gigabyte (G), whereas G and M are the shorthand expressions for GB and MB. For more information see Units of measurement.
scale_initial_instances
integer
Optional initial number of instances that are created upon app creation or app update.
scale_max_instances
integer
Optional maximum number of instances for this app. If you set this value to `0`, this property does not set a upper scaling limit. However, the app scaling is still limited by the project quota for instances. See Limits and quotas for Code Engine.
scale_memory_limit
string
Optional amount of memory set for the instance of the app. For valid values see Supported memory and CPU combinations. The units for specifying memory are Megabyte (M) or Gigabyte (G), whereas G and M are the shorthand expressions for GB and MB. For more information see Units of measurement.
scale_min_instances
integer
Optional minimum number of instances for this app. If you set this value to `0`, the app will scale down to zero, if not hit by any request for some time.
scale_request_timeout
integer
Optional amount of time in seconds that is allowed for a running app to respond to a request.
status
string
The current status of the app revision.
status_details
AppRevisionStatus
The detailed status of the application revision.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Delete an application
DELETE /projects/{project_id}/apps/{name}
Delete an application.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.delete
Auditing
Calling this method generates the following auditing event.
codeengine.application.readcodeengine.application.delete
Request
Path Parameters
Query Parameters
keep_service_access
boolean
Determines if connected service access secrets remain intact after app deletion.
Response
202 - Accepted
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Get an application
GET /projects/{project_id}/apps/{name}
Display the details of an application.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.application.read
Request
Response
200 - OK
build
string
Reference to a build that is associated with the application.
build_run
string
Reference to a build run that is associated with the application.
computed_env_variables
array
References to config maps, secrets or literal values, which are defined and set by Code Engine and are exposed as environment variables in the application.
created_at
string
The timestamp when the resource was created.
endpoint
string
Optional URL to invoke the app. Depending on visibility, this is accessible publicly or in the private network only. Empty in case 'managed_domain_mappings' is set to 'local'.
endpoint_internal
string
The URL to the app that is only visible within the project.
entity_tag
string
The version of the app instance, which is used to achieve optimistic locking.
href
string
When you provision a new app, a URL is created identifying the location of the instance.
id
string
The identifier of the resource.
image_port
integer
Optional port the app listens on. While the app will always be exposed via port `443` for end users, this port is used to connect to the port that is exposed by the container image.
image_reference
string
The name of the image that is used for this app. The format is `REGISTRY/NAMESPACE/REPOSITORY:TAG` where `REGISTRY` and `TAG` are optional. If `REGISTRY` is not specified, the default is `docker.io`. If `TAG` is not specified, the default is `latest`. If the image reference points to a registry that requires authentication, make sure to also specify the property `image_secret`.
image_secret
string
Optional name of the image registry access secret. The image registry access secret is used to authenticate with a private registry when you download the container image. If the image reference points to a registry that requires authentication, the app will be created but cannot reach the ready status, until this property is provided, too.
managed_domain_mappings
string
Optional value controlling which of the system managed domain mappings will be setup for the application. Valid values are 'local_public', 'local_private' and 'local'. Visibility can only be 'local_private' if the project supports application private visibility.
name
string
The name of the app.
probe_liveness
Probe
Response model for probes
probe_readiness
Probe
Response model for probes
project_id
string
The ID of the project in which the resource is located.
region
string
The region of the project the resource is located in. Possible values: 'au-syd', 'br-sao', 'ca-tor', 'eu-de', 'eu-gb', 'jp-osa', 'jp-tok', 'us-east', 'us-south'.
resource_type
string
The type of the app.
run_arguments
array
Optional arguments for the app that are passed to start the container. If not specified an empty string array will be applied and the arguments specified by the container image, will be used to start the container.
run_as_user
integer
Optional user ID (UID) to run the app.
run_commands
array
Optional commands for the app that are passed to start the container. If not specified an empty string array will be applied and the command specified by the container image, will be used to start the container.
run_compute_resource_token_enabled
boolean
Optional flag to enable the use of a compute resource token mounted to the container file system.
run_env_variables
array
References to config maps, secrets or literal values, which are defined by the app owner and are exposed as environment variables in the application.
run_service_account
string
Optional name of the service account. For built-in service accounts, you can use the shortened names `manager` , `none`, `reader`, and `writer`.
run_volume_mounts
array
Mounts of config maps or secrets.
scale_concurrency
integer
Optional maximum number of requests that can be processed concurrently per instance.
scale_concurrency_target
integer
Optional threshold of concurrent requests per instance at which one or more additional instances are created. Use this value to scale up instances based on concurrent number of requests. This option defaults to the value of the `scale_concurrency` option, if not specified.
scale_cpu_limit
string
Optional number of CPU set for the instance of the app. For valid values see Supported memory and CPU combinations.
scale_down_delay
integer
Optional amount of time in seconds that delays the scale-down behavior for an app instance.
scale_ephemeral_storage_limit
string
Optional amount of ephemeral storage to set for the instance of the app. The amount specified as ephemeral storage, must not exceed the amount of `scale_memory_limit`. The units for specifying ephemeral storage are Megabyte (M) or Gigabyte (G), whereas G and M are the shorthand expressions for GB and MB. For more information see Units of measurement.
scale_initial_instances
integer
Optional initial number of instances that are created upon app creation or app update.
scale_max_instances
integer
Optional maximum number of instances for this app. If you set this value to `0`, this property does not set a upper scaling limit. However, the app scaling is still limited by the project quota for instances. See Limits and quotas for Code Engine.
scale_memory_limit
string
Optional amount of memory set for the instance of the app. For valid values see Supported memory and CPU combinations. The units for specifying memory are Megabyte (M) or Gigabyte (G), whereas G and M are the shorthand expressions for GB and MB. For more information see Units of measurement.
scale_min_instances
integer
Optional minimum number of instances for this app. If you set this value to `0`, the app will scale down to zero, if not hit by any request for some time.
scale_request_timeout
integer
Optional amount of time in seconds that is allowed for a running app to respond to a request.
status
string
The current status of the app.
status_details
AppStatus
The detailed status of the application.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Update an application
PATCH /projects/{project_id}/apps/{name}
An application contains one or more revisions. A revision represents an immutable version of the configuration properties of the application. Each update of an application configuration property creates a new revision of the application. Learn more
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.update
Auditing
Calling this method generates the following auditing event.
codeengine.application.readcodeengine.application.listcodeengine.application.update
Request
Request Body
App patch
Path Parameters
Query Parameters
Response
200 - OK
build
string
Reference to a build that is associated with the application.
build_run
string
Reference to a build run that is associated with the application.
computed_env_variables
array
References to config maps, secrets or literal values, which are defined and set by Code Engine and are exposed as environment variables in the application.
created_at
string
The timestamp when the resource was created.
endpoint
string
Optional URL to invoke the app. Depending on visibility, this is accessible publicly or in the private network only. Empty in case 'managed_domain_mappings' is set to 'local'.
endpoint_internal
string
The URL to the app that is only visible within the project.
entity_tag
string
The version of the app instance, which is used to achieve optimistic locking.
href
string
When you provision a new app, a URL is created identifying the location of the instance.
id
string
The identifier of the resource.
image_port
integer
Optional port the app listens on. While the app will always be exposed via port `443` for end users, this port is used to connect to the port that is exposed by the container image.
image_reference
string
The name of the image that is used for this app. The format is `REGISTRY/NAMESPACE/REPOSITORY:TAG` where `REGISTRY` and `TAG` are optional. If `REGISTRY` is not specified, the default is `docker.io`. If `TAG` is not specified, the default is `latest`. If the image reference points to a registry that requires authentication, make sure to also specify the property `image_secret`.
image_secret
string
Optional name of the image registry access secret. The image registry access secret is used to authenticate with a private registry when you download the container image. If the image reference points to a registry that requires authentication, the app will be created but cannot reach the ready status, until this property is provided, too.
managed_domain_mappings
string
Optional value controlling which of the system managed domain mappings will be setup for the application. Valid values are 'local_public', 'local_private' and 'local'. Visibility can only be 'local_private' if the project supports application private visibility.
name
string
The name of the app.
probe_liveness
Probe
Response model for probes
probe_readiness
Probe
Response model for probes
project_id
string
The ID of the project in which the resource is located.
region
string
The region of the project the resource is located in. Possible values: 'au-syd', 'br-sao', 'ca-tor', 'eu-de', 'eu-gb', 'jp-osa', 'jp-tok', 'us-east', 'us-south'.
resource_type
string
The type of the app.
run_arguments
array
Optional arguments for the app that are passed to start the container. If not specified an empty string array will be applied and the arguments specified by the container image, will be used to start the container.
run_as_user
integer
Optional user ID (UID) to run the app.
run_commands
array
Optional commands for the app that are passed to start the container. If not specified an empty string array will be applied and the command specified by the container image, will be used to start the container.
run_compute_resource_token_enabled
boolean
Optional flag to enable the use of a compute resource token mounted to the container file system.
run_env_variables
array
References to config maps, secrets or literal values, which are defined by the app owner and are exposed as environment variables in the application.
run_service_account
string
Optional name of the service account. For built-in service accounts, you can use the shortened names `manager` , `none`, `reader`, and `writer`.
run_volume_mounts
array
Mounts of config maps or secrets.
scale_concurrency
integer
Optional maximum number of requests that can be processed concurrently per instance.
scale_concurrency_target
integer
Optional threshold of concurrent requests per instance at which one or more additional instances are created. Use this value to scale up instances based on concurrent number of requests. This option defaults to the value of the `scale_concurrency` option, if not specified.
scale_cpu_limit
string
Optional number of CPU set for the instance of the app. For valid values see Supported memory and CPU combinations.
scale_down_delay
integer
Optional amount of time in seconds that delays the scale-down behavior for an app instance.
scale_ephemeral_storage_limit
string
Optional amount of ephemeral storage to set for the instance of the app. The amount specified as ephemeral storage, must not exceed the amount of `scale_memory_limit`. The units for specifying ephemeral storage are Megabyte (M) or Gigabyte (G), whereas G and M are the shorthand expressions for GB and MB. For more information see Units of measurement.
scale_initial_instances
integer
Optional initial number of instances that are created upon app creation or app update.
scale_max_instances
integer
Optional maximum number of instances for this app. If you set this value to `0`, this property does not set a upper scaling limit. However, the app scaling is still limited by the project quota for instances. See Limits and quotas for Code Engine.
scale_memory_limit
string
Optional amount of memory set for the instance of the app. For valid values see Supported memory and CPU combinations. The units for specifying memory are Megabyte (M) or Gigabyte (G), whereas G and M are the shorthand expressions for GB and MB. For more information see Units of measurement.
scale_min_instances
integer
Optional minimum number of instances for this app. If you set this value to `0`, the app will scale down to zero, if not hit by any request for some time.
scale_request_timeout
integer
Optional amount of time in seconds that is allowed for a running app to respond to a request.
status
string
The current status of the app.
status_details
AppStatus
The detailed status of the application.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
List bindings
GET /projects/{project_id}/bindings
List all bindings in a project.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.secret.listcodeengine.application.listcodeengine.job.list
Request
Path Parameters
Query Parameters
limit
integer
Optional maximum number of bindings per page.
start
string
An optional token that indicates the beginning of the page of results to be returned. If omitted, the first page of results is returned. This value is obtained from the 'start' query parameter in the `next` object of the operation response.
Response
200 - OK
bindings
array
List of all bindings.
first
ListFirstMetadata
Describes properties needed to retrieve the first page of a result list.
limit
integer
Maximum number of resources per page.
next
ListNextMetadata
Describes properties needed to retrieve the next page of a result list.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Create a binding
POST /projects/{project_id}/bindings
Create a binding. Creating a service binding with a Code Engine app will update the app, creating a new revision. For more information see the documentation
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.createcodeengine.tenant.entities.update
Auditing
Calling this method generates the following auditing event.
codeengine.secret.createcodeengine.secret.readcodeengine.secret.updatecodeengine.application.listcodeengine.application.updatecodeengine.job.listcodeengine.job.update
Request
Request Body
BindingPrototype
Binding prototype.
component
Required *
ComponentRef
A reference to another component.
name
Required *
string
The name of the referenced component.
resource_type
Required *
string
The type of the referenced resource.
prefix
Required *
string
Optional value that is set as prefix in the component that is bound. Will be generated if not provided.
secret_name
Required *
string
The service access secret that is bound to a component.
Response
201 - Created
component
ComponentRef
A reference to another component.
href
string
When you provision a new binding, a URL is created identifying the location of the instance.
id
string
The ID of the binding.
prefix
string
The value that is set as a prefix in the component that is bound.
project_id
string
The ID of the project in which the resource is located.
resource_type
string
The type of the binding.
secret_name
string
The service access secret that is bound to a component.
status
string
The current status of the binding.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Delete a binding
DELETE /projects/{project_id}/bindings/{id}
Delete a binding.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.deletecodeengine.tenant.entities.update
Auditing
Calling this method generates the following auditing event.
codeengine.secret.listcodeengine.secret.updatecodeengine.application.listcodeengine.application.updatecodeengine.job.listcodeengine.job.update
Request
Response
202 - Accepted
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Get a binding
GET /projects/{project_id}/bindings/{id}
Display the details of a binding.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.secret.list
Request
Response
200 - OK
component
ComponentRef
A reference to another component.
href
string
When you provision a new binding, a URL is created identifying the location of the instance.
id
string
The ID of the binding.
prefix
string
The value that is set as a prefix in the component that is bound.
project_id
string
The ID of the project in which the resource is located.
resource_type
string
The type of the binding.
secret_name
string
The service access secret that is bound to a component.
status
string
The current status of the binding.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
List build runs
GET /projects/{project_id}/build_runs
List all build runs in a project.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.buildrun.list
Request
Path Parameters
Query Parameters
build_name
string
Optional name of the build that should be filtered for.
limit
integer
Optional maximum number of build runs per page.
start
string
An optional token that indicates the beginning of the page of results to be returned. If omitted, the first page of results is returned. This value is obtained from the 'start' query parameter in the `next` object of the operation response.
Response
200 - OK
build_runs
array
List of all build runs.
first
ListFirstMetadata
Describes properties needed to retrieve the first page of a result list.
limit
integer
Maximum number of resources per page.
next
ListNextMetadata
Describes properties needed to retrieve the next page of a result list.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Create a build run
POST /projects/{project_id}/build_runs
Create a build run.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.create
Auditing
Calling this method generates the following auditing event.
codeengine.buildrun.create
Request
Request Body
BuildRunPrototype
Build run prototype
build_name
string
Optional name of the build on which this build run is based on. If specified, the build run will inherit the configuration of the referenced build. If not specified, make sure to specify at least the fields `strategy_type`, `source_url`, `output_image` and `output_secret` to describe the build run.
name
string
Name of the build run. This field is optional, if the field `build_name` is specified and its value will be generated like so: `[BUILD_NAME]-run-[timestamp with format: YYMMDD-hhmmss] if not set.`
output_image
string
The name of the image.
output_secret
string
The secret that is required to access the image registry. Make sure that the secret is granted with push permissions towards the specified container registry namespace.
run_build_params
array
Optional references to config maps and secret keys, or literal values that are exposed as build arguments within the Docker file.
service_account
string
Optional service account, which is used for resource control.
source_context_dir
string
Optional directory in the repository that contains the buildpacks file or the Dockerfile.
source_revision
string
Commit, tag, or branch in the source repository to pull. This field is optional if the `source_type` is `git` and uses the HEAD of default branch if not specified. If the `source_type` value is `local`, this field must be omitted.
source_secret
string
Name of the secret that is used access the repository source. This field is optional if the `source_type` is `git`. Additionally, if the `source_url` points to a repository that requires authentication, the build will be created but cannot access any source code, until this property is provided, too. If the `source_type` value is `local`, this field must be omitted.
source_type
string
Specifies the type of source to determine if your build source is in a repository or based on local source code.
- local - For builds from local source code.
- git - For builds from git version controlled source code.
source_url
string
The URL of the code repository. This field is required if the `source_type` is `git`. If the `source_type` value is `local`, this field must be omitted. If the repository is publicly available you can provide a 'https' URL like `https://github.com/IBM/CodeEngine`. If the repository requires authentication, you need to provide a 'ssh' URL like `git@github.com:IBM/CodeEngine.git` along with a `source_secret` that points to a secret of format `ssh_auth`.
strategy_size
string
Optional size for the build, which determines the amount of resources used. Build sizes are `small`, `medium`, `large`, `xlarge`, `xxlarge`.
strategy_spec_file
string
Optional path to the specification file that is used for build strategies for building an image.
strategy_type
string
The strategy to use for building the image.
timeout
integer
The maximum amount of time, in seconds, that can pass before the build must succeed or fail.
Response
202 - Accepted
build_name
string
Optional name of the build on which this build run is based on. If specified, the build run will inherit the configuration of the referenced build. If not specified, make sure to specify at least the fields `strategy_type`, `source_url`, `output_image` and `output_secret` to describe the build run.
created_at
string
The timestamp when the resource was created.
href
string
When you trigger a new build run, a URL is created identifying the location of the instance.
id
string
The identifier of the resource.
name
string
The name of the build run.
output_image
string
The name of the image.
output_secret
string
The secret that is required to access the image registry. Make sure that the secret is granted with push permissions towards the specified container registry namespace.
project_id
string
The ID of the project in which the resource is located.
region
string
The region of the project the resource is located in. Possible values: 'au-syd', 'br-sao', 'ca-tor', 'eu-de', 'eu-gb', 'jp-osa', 'jp-tok', 'us-east', 'us-south'.
resource_type
string
The type of the build run.
run_build_params
array
References to config maps and secret keys, or literal values, which are defined by the build owner and are exposed as build arguments in Docker files.
service_account
string
Optional service account, which is used for resource control.
source_context_dir
string
Optional directory in the repository that contains the buildpacks file or the Dockerfile.
source_revision
string
Commit, tag, or branch in the source repository to pull. This field is optional if the `source_type` is `git` and uses the HEAD of default branch if not specified. If the `source_type` value is `local`, this field must be omitted.
source_secret
string
Name of the secret that is used access the repository source. This field is optional if the `source_type` is `git`. Additionally, if the `source_url` points to a repository that requires authentication, the build will be created but cannot access any source code, until this property is provided, too. If the `source_type` value is `local`, this field must be omitted.
source_type
string
Specifies the type of source to determine if your build source is in a repository or based on local source code.
- local - For builds from local source code.
- git - For builds from git version controlled source code.
source_url
string
The URL of the code repository. This field is required if the `source_type` is `git`. If the `source_type` value is `local`, this field must be omitted. If the repository is publicly available you can provide a 'https' URL like `https://github.com/IBM/CodeEngine`. If the repository requires authentication, you need to provide a 'ssh' URL like `git@github.com:IBM/CodeEngine.git` along with a `source_secret` that points to a secret of format `ssh_auth`.
status
string
The current status of the build run.
status_details
BuildRunStatus
Current status condition of a build run.
strategy_size
string
Optional size for the build, which determines the amount of resources used. Build sizes are `small`, `medium`, `large`, `xlarge`, `xxlarge`.
strategy_spec_file
string
Optional path to the specification file that is used for build strategies for building an image.
strategy_type
string
The strategy to use for building the image.
timeout
integer
The maximum amount of time, in seconds, that can pass before the build must succeed or fail.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Delete a build run
DELETE /projects/{project_id}/build_runs/{name}
Delete a build run.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.delete
Auditing
Calling this method generates the following auditing event.
codeengine.buildrun.delete
Request
Response
202 - Accepted
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Get a build run
GET /projects/{project_id}/build_runs/{name}
Display the details of a build run.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.buildrun.read
Request
Response
200 - OK
build_name
string
Optional name of the build on which this build run is based on. If specified, the build run will inherit the configuration of the referenced build. If not specified, make sure to specify at least the fields `strategy_type`, `source_url`, `output_image` and `output_secret` to describe the build run.
created_at
string
The timestamp when the resource was created.
href
string
When you trigger a new build run, a URL is created identifying the location of the instance.
id
string
The identifier of the resource.
name
string
The name of the build run.
output_image
string
The name of the image.
output_secret
string
The secret that is required to access the image registry. Make sure that the secret is granted with push permissions towards the specified container registry namespace.
project_id
string
The ID of the project in which the resource is located.
region
string
The region of the project the resource is located in. Possible values: 'au-syd', 'br-sao', 'ca-tor', 'eu-de', 'eu-gb', 'jp-osa', 'jp-tok', 'us-east', 'us-south'.
resource_type
string
The type of the build run.
run_build_params
array
References to config maps and secret keys, or literal values, which are defined by the build owner and are exposed as build arguments in Docker files.
service_account
string
Optional service account, which is used for resource control.
source_context_dir
string
Optional directory in the repository that contains the buildpacks file or the Dockerfile.
source_revision
string
Commit, tag, or branch in the source repository to pull. This field is optional if the `source_type` is `git` and uses the HEAD of default branch if not specified. If the `source_type` value is `local`, this field must be omitted.
source_secret
string
Name of the secret that is used access the repository source. This field is optional if the `source_type` is `git`. Additionally, if the `source_url` points to a repository that requires authentication, the build will be created but cannot access any source code, until this property is provided, too. If the `source_type` value is `local`, this field must be omitted.
source_type
string
Specifies the type of source to determine if your build source is in a repository or based on local source code.
- local - For builds from local source code.
- git - For builds from git version controlled source code.
source_url
string
The URL of the code repository. This field is required if the `source_type` is `git`. If the `source_type` value is `local`, this field must be omitted. If the repository is publicly available you can provide a 'https' URL like `https://github.com/IBM/CodeEngine`. If the repository requires authentication, you need to provide a 'ssh' URL like `git@github.com:IBM/CodeEngine.git` along with a `source_secret` that points to a secret of format `ssh_auth`.
status
string
The current status of the build run.
status_details
BuildRunStatus
Current status condition of a build run.
strategy_size
string
Optional size for the build, which determines the amount of resources used. Build sizes are `small`, `medium`, `large`, `xlarge`, `xxlarge`.
strategy_spec_file
string
Optional path to the specification file that is used for build strategies for building an image.
strategy_type
string
The strategy to use for building the image.
timeout
integer
The maximum amount of time, in seconds, that can pass before the build must succeed or fail.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
List builds
GET /projects/{project_id}/builds
List all builds in a project.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.build.list
Request
Path Parameters
Query Parameters
limit
integer
Optional maximum number of builds per page.
start
string
An optional token that indicates the beginning of the page of results to be returned. If omitted, the first page of results is returned. This value is obtained from the 'start' query parameter in the `next` object of the operation response.
Response
200 - OK
builds
array
List of all builds.
first
ListFirstMetadata
Describes properties needed to retrieve the first page of a result list.
limit
integer
Maximum number of resources per page.
next
ListNextMetadata
Describes properties needed to retrieve the next page of a result list.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Create a build
POST /projects/{project_id}/builds
Create a build.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.create
Auditing
Calling this method generates the following auditing event.
codeengine.build.create
Request
Request Body
BuildPrototype
Build prototype
name
Required *
string
The name of the build. Use a name that is unique within the project.
output_image
Required *
string
The name of the image.
output_secret
Required *
string
The secret that is required to access the image registry. Make sure that the secret is granted with push permissions towards the specified container registry namespace.
run_build_params
array
Optional references to config maps and secret keys, or literal values that are exposed as build arguments within the Docker file.
source_context_dir
string
Optional directory in the repository that contains the buildpacks file or the Dockerfile.
source_revision
string
Commit, tag, or branch in the source repository to pull. This field is optional if the `source_type` is `git` and uses the HEAD of default branch if not specified. If the `source_type` value is `local`, this field must be omitted.
source_secret
string
Name of the secret that is used access the repository source. This field is optional if the `source_type` is `git`. Additionally, if the `source_url` points to a repository that requires authentication, the build will be created but cannot access any source code, until this property is provided, too. If the `source_type` value is `local`, this field must be omitted.
source_type
string
Specifies the type of source to determine if your build source is in a repository or based on local source code.
- local - For builds from local source code.
- git - For builds from git version controlled source code.
source_url
string
The URL of the code repository. This field is required if the `source_type` is `git`. If the `source_type` value is `local`, this field must be omitted. If the repository is publicly available you can provide a 'https' URL like `https://github.com/IBM/CodeEngine`. If the repository requires authentication, you need to provide a 'ssh' URL like `git@github.com:IBM/CodeEngine.git` along with a `source_secret` that points to a secret of format `ssh_auth`.
strategy_size
string
Optional size for the build, which determines the amount of resources used. Build sizes are `small`, `medium`, `large`, `xlarge`, `xxlarge`.
strategy_spec_file
string
Optional path to the specification file that is used for build strategies for building an image.
strategy_type
Required *
string
The strategy to use for building the image.
timeout
integer
The maximum amount of time, in seconds, that can pass before the build must succeed or fail.
Response
201 - Created
created_at
string
The timestamp when the resource was created.
entity_tag
string
The version of the build instance, which is used to achieve optimistic locking.
href
string
When you provision a new build, a URL is created identifying the location of the instance.
id
string
The identifier of the resource.
name
string
The name of the build.
output_image
string
The name of the image.
output_secret
string
The secret that is required to access the image registry. Make sure that the secret is granted with push permissions towards the specified container registry namespace.
project_id
string
The ID of the project in which the resource is located.
region
string
The region of the project the resource is located in. Possible values: 'au-syd', 'br-sao', 'ca-tor', 'eu-de', 'eu-gb', 'jp-osa', 'jp-tok', 'us-east', 'us-south'.
resource_type
string
The type of the build.
run_build_params
array
References to config maps and secret keys, or literal values, which are defined by the build owner and are exposed as build arguments in Docker files.
source_context_dir
string
Optional directory in the repository that contains the buildpacks file or the Dockerfile.
source_revision
string
Commit, tag, or branch in the source repository to pull. This field is optional if the `source_type` is `git` and uses the HEAD of default branch if not specified. If the `source_type` value is `local`, this field must be omitted.
source_secret
string
Name of the secret that is used access the repository source. This field is optional if the `source_type` is `git`. Additionally, if the `source_url` points to a repository that requires authentication, the build will be created but cannot access any source code, until this property is provided, too. If the `source_type` value is `local`, this field must be omitted.
source_type
string
Specifies the type of source to determine if your build source is in a repository or based on local source code.
- local - For builds from local source code.
- git - For builds from git version controlled source code.
source_url
string
The URL of the code repository. This field is required if the `source_type` is `git`. If the `source_type` value is `local`, this field must be omitted. If the repository is publicly available you can provide a 'https' URL like `https://github.com/IBM/CodeEngine`. If the repository requires authentication, you need to provide a 'ssh' URL like `git@github.com:IBM/CodeEngine.git` along with a `source_secret` that points to a secret of format `ssh_auth`.
status
string
The current status of the build.
status_details
BuildStatus
The detailed status of the build.
strategy_size
string
Optional size for the build, which determines the amount of resources used. Build sizes are `small`, `medium`, `large`, `xlarge`, `xxlarge`.
strategy_spec_file
string
Optional path to the specification file that is used for build strategies for building an image.
strategy_type
string
The strategy to use for building the image.
timeout
integer
The maximum amount of time, in seconds, that can pass before the build must succeed or fail.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Delete a build
DELETE /projects/{project_id}/builds/{name}
Delete a build.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.delete
Auditing
Calling this method generates the following auditing event.
codeengine.build.delete
Request
Response
202 - Accepted
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Get a build
GET /projects/{project_id}/builds/{name}
Display the details of a build.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.read
Auditing
Calling this method generates the following auditing event.
codeengine.build.read
Request
Response
200 - OK
created_at
string
The timestamp when the resource was created.
entity_tag
string
The version of the build instance, which is used to achieve optimistic locking.
href
string
When you provision a new build, a URL is created identifying the location of the instance.
id
string
The identifier of the resource.
name
string
The name of the build.
output_image
string
The name of the image.
output_secret
string
The secret that is required to access the image registry. Make sure that the secret is granted with push permissions towards the specified container registry namespace.
project_id
string
The ID of the project in which the resource is located.
region
string
The region of the project the resource is located in. Possible values: 'au-syd', 'br-sao', 'ca-tor', 'eu-de', 'eu-gb', 'jp-osa', 'jp-tok', 'us-east', 'us-south'.
resource_type
string
The type of the build.
run_build_params
array
References to config maps and secret keys, or literal values, which are defined by the build owner and are exposed as build arguments in Docker files.
source_context_dir
string
Optional directory in the repository that contains the buildpacks file or the Dockerfile.
source_revision
string
Commit, tag, or branch in the source repository to pull. This field is optional if the `source_type` is `git` and uses the HEAD of default branch if not specified. If the `source_type` value is `local`, this field must be omitted.
source_secret
string
Name of the secret that is used access the repository source. This field is optional if the `source_type` is `git`. Additionally, if the `source_url` points to a repository that requires authentication, the build will be created but cannot access any source code, until this property is provided, too. If the `source_type` value is `local`, this field must be omitted.
source_type
string
Specifies the type of source to determine if your build source is in a repository or based on local source code.
- local - For builds from local source code.
- git - For builds from git version controlled source code.
source_url
string
The URL of the code repository. This field is required if the `source_type` is `git`. If the `source_type` value is `local`, this field must be omitted. If the repository is publicly available you can provide a 'https' URL like `https://github.com/IBM/CodeEngine`. If the repository requires authentication, you need to provide a 'ssh' URL like `git@github.com:IBM/CodeEngine.git` along with a `source_secret` that points to a secret of format `ssh_auth`.
status
string
The current status of the build.
status_details
BuildStatus
The detailed status of the build.
strategy_size
string
Optional size for the build, which determines the amount of resources used. Build sizes are `small`, `medium`, `large`, `xlarge`, `xxlarge`.
strategy_spec_file
string
Optional path to the specification file that is used for build strategies for building an image.
strategy_type
string
The strategy to use for building the image.
timeout
integer
The maximum amount of time, in seconds, that can pass before the build must succeed or fail.
400 - Bad Request
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
401 - Unauthorized
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
403 - Forbidden
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
404 - Not Found
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
500 - Internal Server Error
errors
array
Contains an array with at least one error model.
status_code
integer
Status code used for the response.
trace
string
Lowercase UUID uniquely identifying the request
Update a build
PATCH /projects/{project_id}/builds/{name}
Update a build.
Authorization
To call this method, you must be assigned one or more IAM access roles that include the following action.
codeengine.tenant.entities.update
Auditing
Calling this method generates the following auditing event.
codeengine.build.readcodeengine.build.update
Request
Request Body
Build patch
Path Parameters
Query Parameters
Response
200 - OK
created_at
string
The timestamp when the resource was created.
entity_tag
string
The version of the build instance, which is used to achieve optimistic locking.
href
string
When you provision a new build, a URL is created identifying the location of the instance.
id
string
The identifier of the resource.
name
string
[...]
